/*
 * Copyright (c) 2020. The Kathra Authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Contributors:
 *    IRT SystemX (https://www.kathra.org/)
 *
 */

package org.kathra.usermanager;

import org.kathra.utils.security.KeycloakUtils;
import org.kathra.core.model.Group;
import org.kathra.core.model.User;
import org.apache.camel.model.dataformat.JsonLibrary;
import org.kathra.KathraAuthRequestHandlerImpl;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.cdi.ContextName;
import org.apache.camel.model.rest.RestBindingMode;
import static org.apache.camel.model.rest.RestParamType.*;

@ContextName("UserManager")
public class UserManagerApi extends RouteBuilder {

    @Override
    public void configure() throws Exception {
        KeycloakUtils.init();
        // configure we want to use servlet as the component for the rest DSL
        // and we enable json binding mode
        restConfiguration().component(org.kathra.iface.KathraAuthRequestHandler.HTTP_SERVER)
        // use json binding mode so Camel automatic binds json <--> pojo
        .bindingMode(RestBindingMode.off)
        // and output using pretty print
        .dataFormatProperty("prettyPrint", "true")
        .dataFormatProperty("json.in.disableFeatures", "FAIL_ON_UNKNOWN_PROPERTIES")
        // setup context path on localhost and port number that netty will use
        .contextPath("/api/v1")
        .port("{{env:HTTP_PORT:8080}}")
        .componentProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))
        .endpointProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))
        .consumerProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))

        // add swagger api-doc out of the box
        .apiContextPath("/swagger.json")
        .apiProperty("api.title", "Kathra Users Management API")
        .apiProperty("api.version", "1.2.0")
        .apiProperty("api.description", "UserManager")
        // and enable CORS
        .apiProperty("cors", "true")
        .enableCORS(true).corsAllowCredentials(true)
        .corsHeaderProperty("Access-Control-Allow-Headers", "Origin, Accept, X-Requested-With, Content-Type," +
                "Access-Control-Request-Method, Access-Control-Request-Headers, Authorization");

        rest()

        .post("/users/{userId}/joinGroup/{groupPath}").outType(User.class)
            .description("Assign user to group")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("userId")
                    .type(path)
                    .description("User id")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("groupPath")
                    .type(path)
                    .description("Group Path")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=assignUserToGroup(${header.userId},${header.groupPath})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/groups").type(Group.class).outType(Group.class)
            .description("Create a new group")
                .param()
                    .required(true)
                    .name("group")
                    .type(body)
                    .description("Group object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Group.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=createGroup(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/users").type(User.class).outType(User.class)
            .description("Create a new user")
                .param()
                    .required(true)
                    .name("user")
                    .type(body)
                    .description("User object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,User.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=createUser(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/groups/{groupPath}").outType(Group.class)
            .description("Delete group")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("groupPath")
                    .type(path)
                    .description("Group Path")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=deleteGroup(${header.groupPath})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/users/{userId}").outType(User.class)
            .description("Delete user")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("userId")
                    .type(path)
                    .description("User id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=deleteUser(${header.userId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/groups/{groupPath}").outType(Group.class)
            .description("Return group")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("groupPath")
                    .type(path)
                    .description("Group Path")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=getGroup(${header.groupPath})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/groups").outType(Group[].class)
            .description("Find all groups")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=getGroups")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/users/{userId}/groupsMembers").outType(Group[].class)
            .description("Return groups from user")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("userId")
                    .type(path)
                    .description("User id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=getGroupsAssignationsFromUser(${header.userId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/users/{userId}").outType(User.class)
            .description("Return user")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("userId")
                    .type(path)
                    .description("User id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=getUser(${header.userId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/users").outType(User[].class)
            .description("Find all users")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=getUsers")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/groups/{groupPath}").type(Group.class).outType(Group.class)
            .description("Patch group")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("groupPath")
                    .type(path)
                    .description("Group Path")
                .endParam()
                .param()
                    .required(true)
                    .name("group")
                    .type(body)
                    .description("Group object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Group.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=patchGroup(${header.groupPath},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/users/{userId}").type(User.class).outType(User.class)
            .description("Patch user")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("userId")
                    .type(path)
                    .description("User id")
                .endParam()
                .param()
                    .required(true)
                    .name("user")
                    .type(body)
                    .description("User object to be patched")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,User.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=patchUser(${header.userId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/users/{userId}/quitGroup/{groupPath}").outType(User.class)
            .description("Unassign user to group")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("userId")
                    .type(path)
                    .description("User id")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("groupPath")
                    .type(path)
                    .description("Group Path")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=unassignUserToGroup(${header.userId},${header.groupPath})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/groups/{groupPath}").type(Group.class).outType(Group.class)
            .description("Update group")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("groupPath")
                    .type(path)
                    .description("Group Path")
                .endParam()
                .param()
                    .required(true)
                    .name("group")
                    .type(body)
                    .description("Group object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Group.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=updateGroup(${header.groupPath},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/users/{userId}").type(User.class).outType(User.class)
            .description("Update user")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("userId")
                    .type(path)
                    .description("User id")
                .endParam()
                .param()
                    .required(true)
                    .name("user")
                    .type(body)
                    .description("User object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,User.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UserManagerController?method=updateUser(${header.userId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest();
    }
}